<?php 
require '../../global.php';
!defined('INC') && exit("Illegal request!");
/**
 * UCenter API
 *
 * This is NOT a freeware, use is subject to license terms
 * 
 * $Author: kingcms $
 * $Id: uc.php 17217 2011-01-19 06:29:08Z kingcms $
 */

define('UC_CLIENT_VERSION', '1.6.0');	//UCenter 版本标识
define('UC_CLIENT_RELEASE', '20110501');

define('API_DELETEUSER', 1);            //用户删除 API 接口开关
define('API_RENAMEUSER', 1);            //用户改名 API 接口开关
define('API_GETTAG', 1);                //获取标签 API 接口开关
define('API_SYNLOGIN', 1);              //同步登录 API 接口开关
define('API_SYNLOGOUT', 1);             //同步登出 API 接口开关
define('API_UPDATEPW', 1);              //更改用户密码 开关
define('API_UPDATEBADWORDS', 1);        //更新关键字列表 开关
define('API_UPDATEHOSTS', 1);           //更新域名解析缓存 开关
define('API_UPDATEAPPS', 1);            //更新应用列表 开关
define('API_UPDATECLIENT', 1);          //更新客户端缓存 开关
define('API_UPDATECREDIT', 1);          //更新用户积分 开关
define('API_GETCREDITSETTINGS', 1);     //向 UCenter 提供积分设置 开关
define('API_GETCREDIT', 1);             //获取用户的某项积分 开关
define('API_UPDATECREDITSETTINGS', 1);  //更新应用积分设置 开关
define('API_RETURN_SUCCEED', '1');
define('API_RETURN_FAILED', '-1');
define('API_RETURN_FORBIDDEN', '-2');

if(!defined('IN_UC')) {
    set_magic_quotes_runtime(0);	
	$db = new db;
	$rs = $db->getRows_one('%s_config','value',"class='uc' and name='config'");
	if(!empty($rs)) {
		$setting = json_decode($rs['value'],true);
		if(!empty($setting) && $setting['status'] == '1') {
			define('UC_CONNECT', $setting['connect'] == 'mysql' ? 'mysql' : '');
			define('UC_DBHOST', isset($setting['dbhost'])?$setting['dbhost']:'');
			define('UC_DBUSER', isset($setting['dbuser'])?$setting['dbuser']:'');
			define('UC_DBPW', isset($setting['dbpw'])?$setting['dbpw']:'');
			define('UC_DBNAME', isset($setting['dbname'])?$setting['dbname']:'');
			define('UC_DBCHARSET', isset($setting['dbcharset'])?$setting['dbcharset']:'');
			define('UC_DBTABLEPRE', isset($setting['dbtablepre'])?$setting['dbtablepre']:'');
			define('UC_DBCONNECT', 0);
			define('UC_KEY', isset($setting['key'])?$setting['key']:'');
			define('UC_API', isset($setting['api'])?$setting['api']:'');
			define('UC_CHARSET', isset($setting['charset'])?$setting['charset']:'');
			define('UC_IP', isset($setting['ip'])?$setting['ip']:'');
			define('UC_APPID', isset($setting['appid'])?$setting['appid']:'');
		}
	}
	
    $get = $post = array();
    $code = @$_GET['code'];

    parse_str(_authcode($code, 'DECODE', UC_KEY), $get);
    $get = _stripslashes($get);
	
    $timestamp = time();
    if($timestamp - $get['time'] > 3600){
        exit('Authracation has expiried');
    }
    if(empty($get)){
        exit('Invalid Request');
    }

	include_once ROOT.'uc_client/lib/xml.class.php';
	$post = xml_unserialize(file_get_contents('php://input'));

	if(in_array($get['action'], array('test', 'deleteuser', 'renameuser', 'gettag', 'synlogin', 'synlogout', 'updatepw', 'updatebadwords', 'updatehosts', 'updateapps', 'updateclient', 'updatecredit', 'getcredit', 'getcreditsettings', 'updatecreditsettings', 'addfeed'))) {
		$uc_note = new uc_note();
		echo $uc_note->$get['action']($get, $post);
		exit();
	} else {
		exit(API_RETURN_FAILED);
	}
} else {
	exit;
}

class uc_note {
	var $db = '';
	var $tablepre = '';
	var $appdir = '';

	function _serialize($arr, $htmlon = 0) {
		if(!function_exists('xml_serialize')) {
			include_once ROOT.'uc_client/lib/xml.class.php';
		}
		return xml_serialize($arr, $htmlon);
	}

	function uc_note() {
        $this->appdir = ROOT;
		$db= new db;
        $this->db = $db;
	}

	function test($get, $post) {
		return API_RETURN_SUCCEED;
	}
	
    function deleteuser($get, $post) {
        if(!API_DELETEUSER){
            return API_RETURN_FORBIDDEN;
        }
		$uids = $get['ids'];
        if (empty($uids)){
            return API_RETURN_FAILED;
        }
		
        /* 同步删除本地用户 */
		 $uids = stripslashes($uids);
		$this->db->delete('%s_user', "userid IN ($uids)");
		
        return API_RETURN_SUCCEED;
    }
	
    function renameuser($get, $post) {
        if(!API_RENAMEUSER){
            return API_RETURN_FORBIDDEN;
        }
        $uid = $get['uid'];
        $usernameold = $get['oldusername'];
        $usernamenew = $get['newusername'];
		$this->db->update('%s_user',array('username'=>$usernamenew),'userid='.$uid);		

        return API_RETURN_SUCCEED;
    }
	
    function gettag($get, $post) {
		global $_G;
		if(!API_GETTAG) {
			return API_RETURN_FORBIDDEN;
		}
		return $this->_serialize(array($get['id'], array()), 1);
	}
	
    function synlogin($get, $post) {
        if(!API_SYNLOGIN){
            return API_RETURN_FORBIDDEN;
        }
        header('P3P: CP="CURa ADMa DEVa PSAo PSDo OUR BUS UNI PUR INT DEM STA PRE COM NAV OTC NOI DSP COR"');
        $uid = intval($get['uid']);
        $username = $get['username'];
        set_login($uid, $username);
    }
	
    function synlogout($get, $post) {
        if(!API_SYNLOGOUT){
            return API_RETURN_FORBIDDEN;
        }

        header('P3P: CP="CURa ADMa DEVa PSAo PSDo OUR BUS UNI PUR INT DEM STA PRE COM NAV OTC NOI DSP COR"');
		kc_setCookie('userauth','',-864000);
    }
	
    function updatepw($get, $post) {
        if(!API_UPDATEPW){
            return API_RETURN_FORBIDDEN;
        }
		$username = $get['username'];
		$newpw = md5(time().rand(100000, 999999));
		$this->db->update('%s_user',array('userpass'=>$newpw),"username='$username'");
        return API_RETURN_SUCCEED;
    }
	
    function updatebadwords($get, $post) {
        if(!API_UPDATEBADWORDS){
            return API_RETURN_FORBIDDEN;
        }
        $cachefile = $this->appdir.'uc_client/data/cache/badwords.php';
        $fp = fopen($cachefile, 'w');
        $data = array();
        if(is_array($post)) {
            foreach($post as $k => $v) {
                $data['findpattern'][$k] = $v['findpattern'];
                $data['replace'][$k] = $v['replacement'];
            }
        }
        $s = "<?php\r\n";
        $s .= '$_CACHE[\'badwords\'] = '.var_export($data, TRUE).";\r\n";
        fwrite($fp, $s);
        fclose($fp);
        return API_RETURN_SUCCEED;
    }
	
    function updatehosts($get, $post) {
        if(!API_UPDATEHOSTS){
            return API_RETURN_FORBIDDEN;
        }
        $cachefile = $this->appdir . 'uc_client/data/cache/hosts.php';
        $fp = fopen($cachefile, 'w');
        $s = "<?php\r\n";
        $s .= '$_CACHE[\'hosts\'] = '.var_export($post, TRUE).";\r\n";
        fwrite($fp, $s);
        fclose($fp);
        return API_RETURN_SUCCEED;
    }
	
    function updateapps($get, $post) {
        if(!API_UPDATEAPPS){
            return API_RETURN_FORBIDDEN;
        }
        $UC_API = $post['UC_API'];

        $cachefile = $this->appdir . 'uc_client/data/cache/apps.php';
        $fp = fopen($cachefile, 'w');
        $s = "<?php\r\n";
        $s .= '$_CACHE[\'apps\'] = '.var_export($post, TRUE).";\r\n";
        fwrite($fp, $s);
        fclose($fp);
        return API_RETURN_SUCCEED;
    }
	
	function updateclient($get, $post) {
		if(!API_UPDATECLIENT) {
			return API_RETURN_FORBIDDEN;
		}
		$cachefile = $this->appdir.'uc_client/data/cache/settings.php';
		$fp = fopen($cachefile, 'w');
		$s = "<?php\r\n";
		$s .= '$_CACHE[\'settings\'] = '.var_export($post, TRUE).";\r\n";
		fwrite($fp, $s);
		fclose($fp);
		return API_RETURN_SUCCEED;
	}
}
/**
 * 设置用户登陆
 *
 * @access  public
 * @param int $userid
 * @param string $username
 * @return void
 */
function set_login($userid = '', $username = '') {
    if (empty($userid)){
        return ;
    }
    else{
		$db=new db;
		$rs=$db->getRows_one('%s_user','username,userpass','userid='.$userid);
        if ($row){
			kc_log(array('userid'=>$rs['userid'],'app'=>'user','action'=>'USER_LOGIN','cid'=>$rs['userid']));
			kc_setCookie('userauth',md5($rs['userpass']).$rs['userid'],8640000);
        }
        else{
            include_once(ROOT . 'uc_client/client.php');
            if($data = uc_get_user($username)){
                list($uid, $uname, $email) = $data;
				$upass = md5('123456');
                $sql = "REPLACE INTO ".DB_PRE."_user(userid, username, userpass, email) VALUES('$uid', '$uname', '$upass', '$email')";
				$db->query($sql);
                set_login($uid);
            }
            else{
                return false;
            }
        }
    }
}

function _authcode($string, $operation = 'DECODE', $key = '', $expiry = 0) {
    $ckey_length = 4;
    $key = md5($key ? $key : UC_KEY);
    $keya = md5(substr($key, 0, 16));
    $keyb = md5(substr($key, 16, 16));
    $keyc = $ckey_length ? ($operation == 'DECODE' ? substr($string, 0, $ckey_length): substr(md5(microtime()), -$ckey_length)) : '';

    $cryptkey = $keya.md5($keya.$keyc);
    $key_length = strlen($cryptkey);

    $string = $operation == 'DECODE' ? base64_decode(substr($string, $ckey_length)) : sprintf('%010d', $expiry ? $expiry + time() : 0).substr(md5($string.$keyb), 0, 16).$string;
    $string_length = strlen($string);

    $result = '';
    $box = range(0, 255);

    $rndkey = array();
    for($i = 0; $i <= 255; $i++) {
        $rndkey[$i] = ord($cryptkey[$i % $key_length]);
    }

    for($j = $i = 0; $i < 256; $i++) {
        $j = ($j + $box[$i] + $rndkey[$i]) % 256;
        $tmp = $box[$i];
        $box[$i] = $box[$j];
        $box[$j] = $tmp;
    }

    for($a = $j = $i = 0; $i < $string_length; $i++) {
        $a = ($a + 1) % 256;
        $j = ($j + $box[$a]) % 256;
        $tmp = $box[$a];
        $box[$a] = $box[$j];
        $box[$j] = $tmp;
        $result .= chr(ord($string[$i]) ^ ($box[($box[$a] + $box[$j]) % 256]));
    }

    if($operation == 'DECODE') {
        if((substr($result, 0, 10) == 0 || substr($result, 0, 10) - time() > 0) && substr($result, 10, 16) == substr(md5(substr($result, 26).$keyb), 0, 16)) {
            return substr($result, 26);
        } else {
                return '';
            }
    } else {
        return $keyc.str_replace('=', '', base64_encode($result));
    }
}

function _stripslashes($string) {
    if(is_array($string)) {
        foreach($string as $key => $val) {
            $string[$key] = _stripslashes($val);
        }
    } else {
        $string = stripslashes($string);
    }
    return $string;
}
?>