<?php


/**
 * 加密函数
 * @param   string  $str    加密前的字符串
 * @param   string  $key    密钥
 * @return  string  加密后的字符串
 */
function encrypt($str, $key = AUTH_KEY){
    $coded = '';
    $keylength = strlen($key);
    for ($i = 0, $count = strlen($str); $i < $count; $i += $keylength){
        $coded .= substr($str, $i, $keylength) ^ $key;
    }
    return str_replace('=', '', base64_encode($coded));
}
/**
 * 解密函数
 * @param   string  $str    加密后的字符串
 * @param   string  $key    密钥
 * @return  string  加密前的字符串
 */
function decrypt($str, $key = AUTH_KEY){
    $coded = '';
    $keylength = strlen($key);
    $str = base64_decode($str);
    for ($i = 0, $count = strlen($str); $i < $count; $i += $keylength){
        $coded .= substr($str, $i, $keylength) ^ $key;
    }
    return $coded;
}
//string对象
function jsonString($str) {
	return preg_replace("/([\\\\\/'])/",'\\\$1',$str);
}
//用户消费的金额
function get_user_payed($userid){
	$db=new db;
	$rs=$db->getRows_one('%s_user_account_log','SUM(user_money) as user_payed_money',"userid = '$userid' AND user_money < 0");
    return abs($rs['user_payed_money']);
}
//用户的余额
function get_user_yue($userid){
	$db=new db;
	$rs=$db->getRows_one('%s_user','user_money',"userid = '$userid'");
	return $rs['user_money'];
}
/**
 * 记录帐户变动
 * @param   int     $user_id        用户id
 * @param   float   $user_money     可用余额变动
 * @param   float   $frozen_money   冻结余额变动
 * @param   string  $change_desc    变动说明
 * @param   int     $change_type    变动类型：参见常量文件
 * @return  void
 */
function log_account_change($userid, $user_money = 0, $frozen_money = 0, $change_desc = '', $change_type = ACT_OTHER){
	$db=new db;
    //插入帐户变动记录
    $account_log = array(
        'userid'       => $userid,
        'user_money'    => $user_money,
        'frozen_money'  => $frozen_money,
        'change_time'   => time(),
        'change_desc'   => $change_desc,
        'change_type'   => $change_type
    );
	$db->insert('%s_user_account_log',$account_log);	
    //更新用户信息
    $sql = "UPDATE ".DB_PRE."_user SET user_money = user_money + ('$user_money'), frozen_money = frozen_money + ('$frozen_money') WHERE userid = '$userid' LIMIT 1";
    $db->query($sql);
}
?>