<?php
define('KC_KEY','fd4kk4k6ll234h23ser5');
global $lang;
$lang=require 'lang.php';

//系统环境检测项
function check_sys_env(){
        //规则,结果,显示
        $check_env = check_env(array(
            'php_version'   =>  array(
			    'text'  	=> 'PHP版本',
                'required'  => '>= 4.3',
                'checker'   => 'php_checker',
            ),
            'gd_version'   =>  array(
				'text'  	=> 'GD库版本',
                'required'  => '>= 1.0',
                'checker'   => 'gd_checker',
            ),
        ));
        $check_file= check_sys_file(array(
            './_cache',
            './user',
            './apps',
			'./upfiles',
        ));
        $compatible = false;
        if ($check_env['compatible'] && $check_file['compatible'])
        {
            $compatible = true;
        }
		return array('check_env'=>$check_env,'check_file'=>$check_file,'messages'=>array_merge($check_env['msg'], $check_file['msg']),'compatible'=>$compatible);
}
//检查环境
function check_env($required){
	global $lang;
    $return  = array('detail' => array(), 'compatible' => true, 'msg' => array());
    foreach ($required as $key => $value){
            $checker = $value['checker'];
            $result = $checker();
            $return['detail'][$key] = array(
				'text'  	=> $value['text'],
                'required'  => $value['required'],
                'current'   => $result['current'],
                'result'    => $result['result'] ? 'pass' : 'failed',
            );
            if (!$result['result']){
                $return['compatible'] = false;
                $return['msg'][] = $lang[$key . '_error'];
            }
    }
    return $return;
}
//检查系统文件目录是否可写
function check_sys_file($file_list){
	global $lang;
    $return = array('detail' => array(), 'compatible' => true, 'msg' => array());
    foreach ($file_list as $key => $value){
            $result = check_file(ROOT . $value);
            $return['detail'][] = array(
                'file'  =>  $value,
                'result'=>  $result ? 'pass' : 'failed',
                'current'   =>  $result ? $lang['writable'] : $lang['unwritable'],
            );
            if (!$result){
                $return['compatible'] = false;
                $return['msg'][] = sprintf($lang['file_error'], $value);
            }
    }
    return $return;
}
//检查PHP版本
function php_checker(){
    return array(
        'current' => PHP_VERSION,
        'result'  => (PHP_VERSION >= 4.3),
    );
}
//检查GD版本
function gd_checker(){
    $return = array('current' => null, 'result' => false);
    $gd_info = function_exists('gd_info') ? gd_info() : array();
    $return['current'] = empty($gd_info['GD Version']) ? '缺少GD库' : $gd_info['GD Version'];
    $return['result']  = empty($gd_info['GD Version']) ? false : true;
    return $return;
}
//检查文件或目录是否可写
function check_file($file){
    if (!file_exists($file)){
        //不存在，则不可写
        return false;
    }
    if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN'){
        if (is_dir($file)){
            /* 如果是目录，则尝试创建文件并修改 */
            $trail = substr($file, -1);
            if ($trail == '/' || $trail == '\\'){
                $tmpfile = $file . '___test_dir_file.txt';
            }else{
                $tmpfile = $file . '/' . '___test_dir_file.txt';
            }
            /* 尝试创建文件 */
            if (false === @touch($tmpfile)){
                /* 不可写 */
                return false;
            }
            /* 创建文件成功 */
            /* 尝试修改该文件 */
            if (false === @touch($tmpfile)){
                return false;
            }
            /* 修改文件成功 */
            /* 删除文件 */
            @unlink($tmpfile);
            return true;
        }else{
            /* 如果是文件，则尝试修改文件 */
            if (false === @touch($file)){
                /* 修改不成功，不可写 */
                return false;
            }else{
                /* 修改成功，可写 */
                return true;
            }
        }
    }else{
        return is_writable($file);
    }
}

function authcode($string, $operation = 'DECODE', $key = '', $expiry = 0) {
    $ckey_length = 4;
    $key = md5($key ? $key : KC_KEY);
    $keya = md5(substr($key, 0, 16));
    $keyb = md5(substr($key, 16, 16));
    $keyc = $ckey_length ? ($operation == 'DECODE' ? substr($string, 0, $ckey_length): substr(md5(microtime()), -$ckey_length)) : '';

    $cryptkey = $keya.md5($keya.$keyc);
    $key_length = strlen($cryptkey);

    $string = $operation == 'DECODE' ? base64_decode(substr($string, $ckey_length)) : sprintf('%010d', $expiry ? $expiry + time() : 0).substr(md5($string.$keyb), 0, 16).$string;
    $string_length = strlen($string);

    $result = '';
    $box = range(0, 255);

    $rndkey = array();
    for($i = 0; $i <= 255; $i++) {
        $rndkey[$i] = ord($cryptkey[$i % $key_length]);
    }

    for($j = $i = 0; $i < 256; $i++) {
        $j = ($j + $box[$i] + $rndkey[$i]) % 256;
        $tmp = $box[$i];
        $box[$i] = $box[$j];
        $box[$j] = $tmp;
    }

    for($a = $j = $i = 0; $i < $string_length; $i++) {
        $a = ($a + 1) % 256;
        $j = ($j + $box[$a]) % 256;
        $tmp = $box[$a];
        $box[$a] = $box[$j];
        $box[$j] = $tmp;
        $result .= chr(ord($string[$i]) ^ ($box[($box[$a] + $box[$j]) % 256]));
    }

    if($operation == 'DECODE') {
        if((substr($result, 0, 10) == 0 || substr($result, 0, 10) - time() > 0) && substr($result, 10, 16) == substr(md5(substr($result, 26).$keyb), 0, 16)) {
            return substr($result, 26);
        } else {
                return '';
            }
    } else {
        return $keyc.str_replace('=', '', base64_encode($result));
    }
}
?>