<?php

//内容缓存
class obcache{
	/**
	 * 缓存开始读取
	 * @param string $name 键名
	 */
	function get($name){
		ob_end_flush();
		ob_start();
		$path=ROOT.PATH_CACHE."/$name.ob.php";
		if (is_file($path)) {
			$text=file_get_contents($path);
			$array=unserialize(substr($text,13));
			$time=kc_val($array,'time');
			//如果有效时间小于当前时间，则作废
			if ($time<time()){
				$cache=new cache;
				$cache->del($name);
				return false;
			}
			echo kc_val($array,'value');
		}else{
			return false;
		}
	}
	/**
	 * 设置缓存
	 * @param string $name 键名
	 * @param integer $time 时间,默认为30天
	 * @return string 写入值,即$value
	 */
	function set($name,$time=2592000){
		$path=PATH_CACHE."/$name.ob.php";
		$value=ob_get_contents();
		$array=array(
			'time'=>time()+$time,
			'value'=>$value,
		);		
		$text='<?php exit ?>'.serialize($array);
		$file=new file;
		$file->put($path,$text);
		return $value;
	}
	/**
	 * 删除缓存
	 * @param string $name 键值
	 */
	function del($name){
		$path=ROOT.PATH_CACHE."/$name.ob.php";
		if(is_file($path)){
			unlink($path);
		}
	}
}
?>