<?php

class sms{
    //请求处理url
    var $_query_url = '';
    //短信平台唯一标识
    var $_code = '';
    //返回状态
    var $_status = 0;
	//出错提示
	var $_errstr = array();
	//短信接口配置
	var $_config = array();
	//数据库对象
	var $db;
	
    public function __construct(){
        $this->sms();
    }
	
    public function sms(){
        $this->db = new db;
		$res  = $this->db->getRows_one('%s_sms_api','*','if_default=1','api_id desc');	
		if(!$res){
			$this->_errstr[] = '短信接口尚未设置默认接口';
			return false;
		}
		$this->_config   = $res;
		$this->clear();
	}
    /**
     * 清除过期的验证码记录
     * @return  void
     */
    function clear()
    {
		$this->db->delete('%s_sms_captcha',"end_time < " . time());		
    }
    /**
     *    生成包含请求数据的url
     *    @author    tianya
     *    @param     array  $params
     *    @return    string
     */
	function create_sendurl($params=array()){
		$query_str = '';
		$temp = array();
		foreach($params as $key=>$value){
			$temp[] = "{$key}={$value}";
		}
		$query_str = implode('&', $temp);
		unset($temp);
		return $this->_query_url . $query_str;
	}
    /**
     *    获取短信内容
     *    @param     string $tplcode
     *    @return    mixed
     */
	function getcontent($tplcode){
		$res  = $this->db->getRows_one('%s_sms_tpl','content',"tplcode='$tplcode'");	
		if(!$res){
			$this->_errstr[] = '该短信模板不存在';
			return false;
		}else{
			$res['content'] = addslashes($res['content']);
			return $res['content'];
		}
	}
    /**
     *    发送短信
     *    @param     mixed $sms_info 要发送的手机号码、内容等信息
     *    @return    mixed
     */
	function send($sms_info=array()){
		$res  = $this->db->getRows_one('%s_sms_api','*','if_default=1','api_id desc');	
		if($res){
			$sms_info['api_id'] = $res['api_id'];
			$code = $res['smsapi_code'];
			
			$apipath=ROOT.'user/smsapi/' . $code . '.php';
			$apipath_apps=ROOT.'apps/sms/smsapi/' . $code . '.php';
			if(file_exists($apipath)){
				include_once($apipath);
			}else if(file_exists($apipath_apps)){
				include_once($apipath_apps);
			}
			$sms_api =new $code($res);
			$smsResult = $sms_api->send_sms($sms_info);	//发送短信
			if($smsResult < 0){
				$this->_errstr[] = '短信发送失败，请与管理员联系';
				return false;
			}
		}else{
			$this->_errstr[] = '尚未开启短信默认接口';
			return false;
		}
	}
    /**
     *    获取url的内容数据
     *    @author    tianya
     *    @param     string $url
     *    @return    mixed
     */
    function get_api_contents($url = ''){
		if(!$url){
			return '';
		}
		$url = str_replace(' ', '%20', $url);
		if(function_exists('file_get_contents')){
			$file_contents = file_get_contents($url);
		}
		else{
			$ch = curl_init();
			$timeout = 5;
			curl_setopt ($ch, CURLOPT_URL, $url);
			curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
			$file_contents = curl_exec($ch);
			curl_close($ch);
		}		
		return $file_contents;
    }
	
    /**
     *    将发送的短信的内容记录
     *    @author    tianya
     *    @param     array $sms_info
     *    @return    mixed
     */
	function local_add_sms($sms_info){
		$smsid = $this->db->insert('%s_sms',$sms_info);
		return $smsid;
	}	
	/**
     *    更新短信记录
     *    @author    tianya
     *    @param     int $smsid
     *    @param     array $data
     *    @return    void
     */
	function local_edit_sms($smsid, $data){
		$this->db->update('%s_sms',$data,"smsid='$smsid'");
	}	
	//php post https数据
	function posthttpsData($remote_server='', $argv='', $cookie=''){
		if(is_array($argv)){
			$params = http_build_query($argv);
		}else{
			$params = $argv;
		}
		$curl = curl_init(); // 启动一个CURL会话
		curl_setopt($curl, CURLOPT_URL, $remote_server); // 要访问的地址
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0); // 对认证证书来源的检查
		curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 1); // 从证书中检查SSL加密算法是否存在
		curl_setopt($curl, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']); // 模拟用户使用的浏览器
		curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1); // 使用自动跳转
		curl_setopt($curl, CURLOPT_COOKIEJAR, $cookie); // 注意这里！保存Cookie
		curl_setopt($curl, CURLOPT_AUTOREFERER, 1); // 自动设置Referer
		curl_setopt($curl, CURLOPT_POST, 1); // 发送一个常规的Post请求
		curl_setopt($curl, CURLOPT_POSTFIELDS, $params); // Post提交的数据包
		curl_setopt($curl, CURLOPT_TIMEOUT, 30); // 设置超时限制防止死循环
		curl_setopt($curl, CURLOPT_HEADER, 0); // 显示返回的Header区域内容
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); // 获取的信息以文件流的形式返回
		$data = curl_exec($curl); // 执行操作
	    curl_close($curl);
		return $data;
	}	
    /**
     * 获得最后一个错误信息
     * @access  public
     * @return  string
     */
    function show_errstr(){
        if (!empty($this->_errstr)){
            $len = count($this->_errstr) - 1;
            return $this->_errstr[$len];
        }
        else{
            return '';
        }
    }
}
?>